// Modelamento PCR e PLS com deteco de outliers.
function []=pcrpls(X,Y)
stacksize(59000000)
l1=list('the spectra are along',2,['rows','columns']);
l2=list('the reference values are along',1,['rows','columns']);
Pergunta=x_choices('',list(l1,l2));
if Pergunta(1)==2
	X=X';
end
if Pergunta(2)==2
	Y=Y';
end

[m,n]=size(X); 
[Cm,Cn]=size(Y);
if Cm~=m
	disp(['O numero de amostras na matriz de dados  '+string(m) ;'e o nmero de amostras da matriz de resultados '+string(Cm); 'Eles no podem ser diferentes']);
	disp(['The number of samples on the data matrix is'+string(m) ;'and the number of samples on the result matrix is'+string(Cm);'It cannot be different']);
	abort
end

labels=[""];
[ok,valida]=getvalue('You have '+string(m)+' samples. How many do you want to separate for validation?',labels,list("vec",1),["30"]);
Xval=[X(1:valida,:)];
X=[X(valida+1:m,:)];
Yval=[Y(1:valida,:)]; 
Y=[Y(valida+1:m,:)];
[m1,n1]=size(Xval);
[m,n]=size(X); //n nmero de comprimentos de onda e m nmero de amostras
[Cm,Cn]=size(Y);
for i=1:m
	Numdaamostra(i,1)=i+valida;
end
for i=1:valida
	Numdaamostraval(i,1)=i;
end
x_message(['Available pre-treatments:';'Normalize: Dividir each point of the spectra by the square root of the sum of all the points of the same spectra';'Mean centering: Subtract of each spectra the average of the calibration spectra';'Variance scale: divide each element by the standard deviation calculated in the calibration samples or each point of the spectra']);
l1=list('Normalize',1,['yes','no']);
l2=list('Mean center',1,['yes','no']);
l3=list('variance scale',1,['yes','no']);
Pergunta=x_choices('Pre treatment of spectra',list(l1,l2,l3));

Xtratado=X;
Xvaltratado=Xval;
Normaliza=Pergunta(1);
Centra=Pergunta(2);
Autoescala=Pergunta(3);
if Pergunta(1)==1
	X2=X.^2;
	Xsum=sum(X2,2);
	Xr=Xsum.^(1/2);
	Xtratado=X./(Xr*ones(1,n));
	X2=Xval.^2;
	Xsum=sum(X2,2);
	Xr=Xsum.^(1/2);
	Xvaltratado=Xval./(Xr*ones(1,n));
end
Ym=0;
um=0;
Xm=mean(Xtratado,1); //media das absorbncias para cada comprimento de onda
if Pergunta(2)==1
	Xtratado=Xtratado-ones(m,1)*Xm; // dados centrados na media
	um=1;
	Xvaltratado=Xvaltratado-ones(m1,1)*Xm;
end
Xstd=st_deviation(Xtratado,1);
if Pergunta(3)==1
	Xtratado=Xtratado./(ones(m,1)*Xstd);
	Xvaltratado=Xvaltratado./(ones(m1,1)*Xstd);
end

[ok,ref]=getvalue('You have '+string(Cn)+' Reference values for each sample. Each reference value correnpond to a column. Which column do you want to model?',labels,list("vec",1),["1"]);

Y=Y(:,ref);
Yval=Yval(:,ref);
if Centra==1
	Ym=mean(Y);
end
Ymax=Y(1);
Ymin=Y(1);
[ok,eignvectors]=getvalue('How many eingnvectors do you want to test?',labels,list("vec",1),["40"]);
//Calculo dos eigenvectors
[U S V]=svd(Xtratado); // V matriz dos eigenvectors

[w,p]=size(diag(S)); // Matriz diagonal que contem os eigenvalues
if w<p
	W=p;
else
	W=w;
end


while eignvectors>W
	disp(['Impossvel no existem tantos eingvectors'])
	disp(['Impossible there are not so many eingvectors'])
	eignvectors=input(['At quantos eingnvectors voc deseja testar?';'how many eingvectors do you want to test']);
end

contador=1;
//Mantendo os eigenvectors significativos utilizando o mtodo PRESS PARA VALIDACAO DOS DADOS

for i=1:m
	if Ymax<Y(i)
		Ymax=Y(i);
	end
	if Ymin>Y(i)
		Ymin=Y(i);
	end
end
Yvalmax=Yval(1);
Yvalmin=Yval(1);
for i=1:m1
	if Yvalmax<Yval(i)
		Yvalmax=Y(i);
	end
	if Yvalmin>Y(i)
		Yvalmin=Yval(i);
	end
end
Ystd=st_deviation(Y);
Yvalstd=st_deviation(Yval);
if Yvalmax-Yvalmin<0.95*(Ymax-Ymin) 
	disp(['the range of the reference values from the validation set' ; 'do not span 95% of the range of calibration reference values'])
end
if Yvalstd<0.95*Ystd 
	disp(['the range of the standard deviation of reference values from the validation set' ; 'do not span 95% of the range of calibration standard deviation of the reference values'])
end
if Yvalmax>Ymax 
	disp(['the maximum reference value from the validation set' ; 'is higher than the maximum reference value from calibration set'])
end
if Yvalmin<Ymin
	disp(['the minimum reference value from the validation set' ; 'is less than the minimum reference value from calibration set'])
end


for k=1:eignvectors
	Beta=V(:,1:k)*inv(S(1:k,1:k))*U(:,1:k)'*Y;
	Press=sum((Yval-((Xvaltratado*Beta)+Ym))^2);
	if k==1
		MPress=Press;
	end
	MatrizPress(k,1)=Press;
	if Press<MPress then;
		Mk=k;
		MPress=Press;
	end
end
// Regenarcao da matriz de calibracao atravs da utilizao de somente os eigenvectors significativos
Mbeta=V(:,1:Mk)*inv(S(1:Mk,1:Mk))*U(:,1:Mk)'*Y;
d=m-Mk-um; //se os dados estao centrados na mdia subtrai-se 1
SEC=sqrt(((Xtratado*Mbeta+Ym-Y)'*(Xtratado*Mbeta+Ym-Y))/d);//erro padro de calibraao
Compara=[Yval (Xvaltratado*Mbeta)+Ym];
[e,j]=size(Compara);
SEV=sqrt(((((Xvaltratado*Mbeta)+Ym)-Yval)'*((Xvaltratado*Mbeta+Ym)-Yval))/(e-um));//erro padro de validao
C=Compara;
for i=1:e-1
	for a=i+1:e
		if Compara(i,1)>Compara(a,1) then
			C(i,:)=Compara(a,:);
			C(a,:)=Compara(i,:);
			Compara=C;
		end
	end
end
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xset("window",0)
xname('Real and Predicted')	
plot(Compara');
xset("window",1)
xname('Press x number of PCs')
plot(MatrizPress')

T=U*S;
h=V(:,1:Mk)*inv(T(:,1:Mk)'*T(:,1:Mk))*T(:,1:Mk)';
for i=1:m
	Lev(i)=Xtratado(i,:)*h(:,i);
end
IntConf=[(Xtratado*Mbeta+Ym)-1.96*SEC*sqrt(1+Lev) (Xtratado*Mbeta+Ym)+1.96*SEC*sqrt(1+Lev)];
Dentro=0;
for i=1:m
	if Y(i)>IntConf(i,1) & Y(i)<IntConf(i,2)
		Dentro=Dentro+1;
	end
end
PorcDentro=(Dentro/m)*100;
resval=(Xvaltratado*Mbeta+Ym)-Yval;
res=(Xtratado*Mbeta+Ym)-Y;
Tcalc=(sum(resval)/m1)*sqrt(m1)/st_deviation(Yval);
Resultados=['Results' 'PCR';'Press' string(MPress); 'Number of PCs' string(Mk); 'Calibration samples' string(m); 'VAlidation samples' string(m1);'% of samples between the confidence limits' string(PorcDentro); 't value' string(Tcalc); 'SEC' string(SEC); 'SEV' string(SEV)]
disp(Resultados)
save('Column'+string(ref)+'Num'+string(contador)+'.sav',Mbeta,Xstd,Xm,Ym,Normaliza,Autoescala,Centra,Resultados,Compara);
continua=1;
q=1;
q1=1;
MPress1=MPress; 
Mk1=Mk; 
m2=m;
m12=m1;
SEC1=SEC;
[spls,ppls]=size(Xtratado);
//Transpondo Y pegando coluna equivalente aos valores do enxofre e definindo variaveis 
Epls=Xtratado;
Fpls=Y;
[npls,mpls]=size(Xvaltratado);
for i=1:eignvectors
	wpls(1:ppls,i)=Epls'*Fpls; // Clculo do vetor dos pesos passo 1
	wpls(1:ppls,i)=wpls(1:ppls,i)/(wpls(1:ppls,i)'*wpls(1:ppls,i)); //normalizando
	tpls(1:spls,i)=Epls*wpls(1:ppls,i); //vetor dos scores
	Ptpls(i,1:ppls)=tpls(1:spls,i)'*Epls/(tpls(1:spls,i)'*tpls(1:spls,i)); //loadings 
	btpls(i)=tpls(1:spls,i)'*Fpls/(tpls(1:spls,i)'*tpls(1:spls,i)); //coeficiente de regresso
	Fpls=Fpls-(tpls(1:spls,i)*btpls(i)); // residuo
	Epls=Epls-(tpls(1:spls,i)*Ptpls(i,1:ppls)); // residuo
	Ppls=Ptpls';
	Beta1=Ppls(:,1:i)*inv(Ppls(:,1:i)'*Ppls(:,1:i))*btpls(1:i,1);
	Presspls=sum((Yval-((Xvaltratado*Beta1)+Ym))^2);
	MatrizPress(i,1)=Presspls;
	if i==1
		MPresspls=Presspls;
	end
	if Presspls<MPresspls then;
		Mkpls=i;
		MPresspls=Presspls;
	end
end
Mbeta1=Ppls(:,1:Mkpls)*inv(Ppls(:,1:Mkpls)'*Ppls(:,1:Mkpls))*btpls(1:Mkpls,1);
Comparapls=[Yval Xvaltratado*Mbeta1+Ym];
SECpls=sqrt(((Xtratado*Mbeta1+Ym-Y)'*(Xtratado*Mbeta1+Ym-Y))/d);
//ordena
Cpls=Comparapls;
[epls,mpls]=size(Comparapls);
SEVpls=sqrt(((((Xvaltratado*Mbeta1)+Ym)-Yval)'*((Xvaltratado*Mbeta1+Ym)-Yval))/(epls-um));//erro padro de validao
for i=1:epls-1
	for apls=i+1:epls
		if Comparapls(i,1)>Comparapls(apls,1) then;
			Cpls(i,:)=Comparapls(apls,:);
			Cpls(apls,:)=Comparapls(i,:);
			Comparapls=Cpls;
		end
	end
end
qpls=1;
apls=1;
xset("window",0)
xname('Real and predicted')	
plot(Comparapls');
xset("window",1)
xname('Press pls x Number of PCs')
plot(MatrizPress')
m1pls=npls;
mpls=spls;
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Resultadospls=['Results' 'PLS';'Press pls' string(MPresspls); 'Number of PCs' string(Mkpls); 'Calibration samples' string(spls); 'Validation samples' string(npls); 'SEC' string(SECpls); 'SEV' string(SEVpls)]
disp(Resultadospls)
save('Column'+string(ref)+'Num'+string(contador)+'PLS'+'.sav',Mbeta1,Xstd,Xm,Ym,Normaliza,Autoescala,Centra,Resultadospls,Comparapls)
out=[];
out1=[];
disp('Deteco de outliers. Enquanto existirem outliers o programa continuar soltando resultados')
disp('Outlier detection. While there are outliers the program will still giving results')
if valida<Mk
	disp(['Voce precisa de mais amostras de validao'])
	disp(['You need more validation samples'])
	abort
end
while continua==1
	stacksize(59000000);
	[U1 S1 V1]=svd(Xvaltratado);
	T1=U1*S1;
	h1=V1(:,1:Mk)*inv(T1(:,1:Mk)'*T1(:,1:Mk))*T1(:,1:Mk)';
	Lev1=0;
	Numdaamostran=0;
	Numdaamostravaln=0;
	Xn=0;
	Yn=0;
	Yvaln=0;
	Xvaln=0;
	Dentro=0;
	a=1;
	a1=1;
	// calculo do resduo de student
	lresc=sqrt((1/(m-1)*((ones(m,1)-Lev).^(-2))'.*res')*res);
	resst=res./(lresc*sqrt(ones(m,1)-Lev));
	for i=1:m1
		Lev1(i)=Xvaltratado(i,:)*h1(:,i);
	end
	outn=out;
	out1n=out1;
	qn=q;
	for i=1:m
		if Lev(i)>3*Mk/m then
			out(q)=Numdaamostra(i);
			q=q+1;
		else
			Xn(a,1:n)=X(i,1:n);
			Yn(a,1)=Y(i,1);
			Numdaamostran(a,1)=Numdaamostra(i,1);
			a=a+1;
		end
	end
	for i=1:m1
		if Lev1(i)>3*Mk/m1 then
			out1(q1)=Numdaamostraval(i);
			q1=q1+1;
		else
			Xvaln(a1,1:n)=Xval(i,1:n);
			Numdaamostravaln(a1,1)=Numdaamostraval(i,1);
			Yvaln(a1,1)=Yval(i,1);
			a1=a1+1;
		end
	end
	[m,n]=size(Xn);
	[m1,n1]=size(Xvaln);//
	Xtratado=Xn;
	Xvaltratado=Xvaln;
	if Normaliza==1
		X2=Xn.^2;
		Xsum=sum(X2,2);
		Xr=Xsum.^(1/2);
		Xtratado=Xn./(Xr*ones(1,n));
		X2=Xvaln.^2;
		Xsum=sum(X2,2);
		Xr=Xsum.^(1/2);
		Xvaltratado=Xvaln./(Xr*ones(1,n));
	end
	Xstd=st_deviation(Xtratado,1);	
	if Autoescala==1

		Xtratado=Xtratado./(ones(m,1)*Xstd);
		Xvaltratado=Xvaltratado./(ones(m1,1)*Xstd);
	end
	Xm=mean(Xtratado,1); //media das absorbncias para cada comprimento de onda
	if Centra==1
		Xtratado=Xtratado-ones(m,1)*Xm; // dados centrados na media
		Ym=mean(Yn);
		Xvaltratado=Xvaltratado-ones(m1,1)*Xm;
	end
	// FAZER NOVO MODELO SEM OS OUTLIERS
	U1=0;
	S1=0;
	V1=0;
	h1=0;
	[U S V]=svd(Xtratado);
	MPress=9999;
	[w,p]=size(diag(S));
	if w<p
		W=p;
	else
		W=w;
	end
	while eignvectors>W
		eignvectors=eingnvectors-1;
	end
	Ymax=Yn(1);
	Ymin=Yn(1);
	for i=1:m
		if Ymax<Yn(i)
			Ymax=Yn(i);
		end
		if Ymin>Yn(i)
			Ymin=Yn(i);
		end
	end
	Yvalmax=Yvaln(1);
	Yvalmin=Yvaln(1);
	for i=1:m1
		if Yvalmax<Yvaln(i)
			Yvalmax=Yvaln(i);
		end
		if Yvalmin>Yvaln(i)
			Yvalmin=Yvaln(i);
		end
	end
	Ystd=st_deviation(Yn);
	Yvalstd=st_deviation(Yvaln);
	if (Yvalmax-Yvalmin)<(0.95*(Ymax-Ymin)) 
		disp(['the range of the reference values from the validation set' ; 'do not span 95% of the range of calibration reference values'])
	end
	if Yvalstd<Ystd 
		disp(['the range of the standard deviation of reference values from the validation set' ; 'do not span 95% of the range of calibration standard deviation of the reference values'])
	end
	if Yvalmax>Ymax 
		disp(['the maximum reference value from the validation set' ; 'is higher than the maximum reference value from calibration set'])
	end
	if Yvalmin<Ymin
		disp(['the minimum reference value from the validation set' ; 'is less than the minimum reference value from calibration set'])
	end
	for k=1:eignvectors
		Beta=V(:,1:k)*inv(S(1:k,1:k))*U(:,1:k)'*Yn;
		Press=sum((Yvaln-((Xvaltratado*Beta)+Ym))^2);
		MatrizPress(k,1)=Press;
		if k==1
			MPress=Press;
		end
		if Press<MPress then;
			Mk=k;
			MPress=Press;
		end
	end
	if Mk<Mk1
		Xvaln=Xval;
		Yvaln=Yval;
		Numdaamostravaln=Numdaamostraval;
		Numdaamostran=Numdaamostra;
		out=outn;
		out1=out1n;
		q=qn;
		Xn=X;
		Yn=Y;
		Xtratado=Xn;
		Xvaltratado=Xval;
		[m,n]=size(Xn);
		[m1,n1]=size(Xvaln);//
		if Normaliza==1
			X2=Xn.^2;
			Xsum=sum(X2,2);
			Xr=Xsum.^(1/2);
			Xtratado=Xn./(Xr*ones(1,n));
			X2=Xvaln.^2;
			Xsum=sum(X2,2);
			Xr=Xsum.^(1/2);
			Xvaltratado=Xvaln./(Xr*ones(1,n));
		end
		Xstd=st_deviation(Xtratado,1);
		if Autoescala==1
			Xtratado=Xtratado./(ones(m,1)*Xstd);	
			Xvaltratado=Xvaltratado./(ones(m1,1)*Xstd);
		end
		Xm=mean(Xtratado,1); //media das absorbncias para cada comprimento de onda
		if Centra==1
			Xtratado=Xtratado-ones(m,1)*Xm; // dados centrados na media
			Ym=mean(Yn);
			Xvaltratado=Xvaltratado-ones(m1,1)*Xm;
		end
		[U S V]=svd(Xtratado);
	end
	outn=out;
	out1n=out1;
	qn=q;
	Numdaamostraval=Numdaamostravaln;
	Numdaamostra=Numdaamostran;
	Xval=Xvaln;
	Yval=Yvaln;
	Mbeta=V(:,1:Mk)*inv(S(1:Mk,1:Mk))*U(:,1:Mk)'*Yn;
	MatrizPress;
	Compara=[Yval (Xvaltratado*Mbeta)+Ym];
	MPress=sum((Yvaln-((Xvaltratado*Mbeta)+Ym))^2);
	//ordena
	C=Compara;
	[m,n]=size(Xn);
	[e,j]=size(Compara);
	for i=1:e-1
		for a=i+1:e
			if Compara(i,1)>Compara(a,1) then;
				C(i,:)=Compara(a,:);
				C(a,:)=Compara(i,:);
				Compara=C;
			end
		end
	end
	d=m-Mk-um; //se os dados estao centrados na mdia subtrai-se 1
	SEC=sqrt(((((Xtratado*Mbeta)+Ym)-Yn)'*((Xtratado*Mbeta+Ym)-Yn))/d);//erro padro de calibraao
	SEV=sqrt(((((Xvaltratado*Mbeta)+Ym)-Yvaln)'*((Xvaltratado*Mbeta+Ym)-Yvaln))/(e-um));//erro padro de validao
	Press=sum((Yval-(Xvaltratado*Mbeta)+Ym)^2);
	res=(Xtratado*Mbeta+Ym)-Yn;
	resval=(Xvaltratado*Mbeta+Ym)-Yval;
	Tcalc=(sum(resval)/m1)*sqrt(m1)/st_deviation(Yval);
	T=U*S;
	h=V(:,1:Mk)*inv(T(:,1:Mk)'*T(:,1:Mk))*T(:,1:Mk)';
	Lev=0;
	for i=1:m
		Lev(i)=Xtratado(i,:)*h(:,i);
	end
	IntConf=[(Xtratado*Mbeta+Ym)-1.96*SEC*sqrt(1+Lev) (Xtratado*Mbeta+Ym)+1.96*SEC*sqrt(1+Lev)];
	for i=1:m
		if Yn(i)>IntConf(i,1) & Yn(i)<IntConf(i,2)
			Dentro=Dentro+1;
		end
	end
	PorcDentro=(Dentro/m)*100;
	// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	Resultados=['Results' 'PCR';'Press' string(MPress); 'Number of PCs' string(Mk); 'Calibration samples' string(m); 'Validation samples' string(m1);'% of samples between the confidence limits' string(PorcDentro); 't value' string(Tcalc); 'SEC' string(SEC); 'SEV' string(SEV)]
	disp(Resultados)
	if Mk1==Mk & m2==m & m12==m1 then
		continua=2;
	end
	MPress1=MPress;
	Mk1=Mk;
	m2=m;
	m12=m1;
	SEC1=SEC;
	xset("window",0)
	xname('Real and predicted')	
	plot(Compara');
	xset("window",1)
	xname('Press x Number of PCs')
	plot(MatrizPress')
	X=Xn;
	Y=Yn;
	contador=contador+1;
	save('Column'+string(ref)+'Num'+string(contador)+'.sav',Mbeta,Xstd,Xm,Ym,Normaliza,Autoescala,Centra,Resultados,Numdaamostra,out,out1,Numdaamostraval,Compara);
	if m1<Mk
		disp('Voce precisa de mais amostras de validao para continuar')
		disp('You need more validation samples to continue')
		abort
	end
	
	[spls,ppls]=size(Xtratado);
	
	//Transpondo Y pegando coluna equivalente aos valores do enxofre e definindo variaveis 
	Epls=Xtratado;
	Fpls=Y;
	[npls,mpls]=size(Xvaltratado);
	MPresspls=999999999999999;
	for i=1:eignvectors
		wpls(1:ppls,i)=Epls'*Fpls; // Clculo do vetor dos pesos passo 1
		wpls(1:ppls,i)=wpls(1:ppls,i)/(wpls(1:ppls,i)'*wpls(1:ppls,i)); //normalizando
		tpls(1:spls,i)=Epls*wpls(1:ppls,i); //vetor dos scores
		Ptpls(i,1:ppls)=tpls(1:spls,i)'*Epls/(tpls(1:spls,i)'*tpls(1:spls,i)); //loadings 
		btpls(i)=tpls(1:spls,i)'*Fpls/(tpls(1:spls,i)'*tpls(1:spls,i)); //coeficiente de regresso
		Fpls=Fpls-(tpls(1:spls,i)*btpls(i)); // residuo
		Epls=Epls-(tpls(1:spls,i)*Ptpls(i,1:ppls)); // residuo
		Ppls=Ptpls';
		Beta1=Ppls(:,1:i)*inv(Ppls(:,1:i)'*Ppls(:,1:i))*btpls(1:i,1);
		Presspls=sum((Yval-((Xvaltratado*Beta1)+Ym))^2);
		MatrizPress(i,1)=Presspls;
		if i==1
			MPresspls=Presspls;
		end
		if Presspls<MPresspls then;
			Mkpls=i;
			MPresspls=Presspls;
		end
	end
	Mbeta1=Ppls(:,1:Mkpls)*inv(Ppls(:,1:Mkpls)'*Ppls(:,1:Mkpls))*btpls(1:Mkpls,1);
	Comparapls=[Yval Xvaltratado*Mbeta1+Ym];
	SECpls=sqrt(((Xtratado*Mbeta1+Ym-Y)'*(Xtratado*Mbeta1+Ym-Y))/d);
	//ordena
	Cpls=Comparapls;
	[epls,mpls]=size(Comparapls);
	SEVpls=sqrt(((((Xvaltratado*Mbeta1)+Ym)-Yval)'*((Xvaltratado*Mbeta1+Ym)-Yval))/(epls-um));//erro padro de validao
	for i=1:epls-1
		for apls=i+1:epls
			if Comparapls(i,1)>Comparapls(apls,1) then;
				Cpls(i,:)=Comparapls(apls,:);
				Cpls(apls,:)=Comparapls(i,:);
				Comparapls=Cpls;
			end
		end
	end
	qpls=1;
	apls=1;
	xset("window",0)
	xname('Real and predicted')	
	plot(Comparapls');
	xset("window",1)
	xname('Press pls x Number of PCs')
	plot(MatrizPress')
	m1pls=npls;
	mpls=spls;
	// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	Resultadospls=['Results' 'PLS';'Press pls' string(MPresspls); 'Number of PCs' string(Mkpls); 'Calibration samples' string(spls); 'Validation samples' string(npls); 'SEC' string(SECpls); 'SEV' string(SEVpls)]
	disp(Resultadospls)
	save('Column'+string(ref)+'Num'+string(contador)+'PLS'+'.sav',Mbeta1,Xstd,Xm,Ym,Normaliza,Autoescala,Centra,Resultadospls,Numdaamostra,out,out1,Numdaamostraval,Comparapls)
end

message(['You have some PCR and PLS models.';'The variable Resultados has data about the results, The variable Compara has on the first column the real reference values and on the second column the values calculated by the model.';' You can consult them using the load command.';'To preview new samples you need to do the same data processing that was made for the model samples';'the preve function will do it automaticaly';'You will need some variables that are on the files:';' Beta (the conversion marix)- For PCR, Beta1 (conversion matrix) for PLS';'Xstd (standard deviation of the columns of the data) ';'Xm (Mean of the columns of the data). Ym (Mean of the reference values)';'To preview you have to multiplicate the processed data by Beta (or Beta1) and sum Ym';'For more details see STD.ASTM E 1655-97']);

